/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.31 from the
 * contents of PAM.xs. Do not edit this file, edit PAM.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "PAM.xs"
#ifdef __cplusplus
extern "C" {
#endif
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#ifdef __cplusplus
}
#endif

#include <PAM_config.h>

#if defined( HAVE_SECURITY_PAM_APPL_H )
# include <security/pam_appl.h>
#else
# if defined( HAVE_PAM_PAM_APPL_H )
#   include <pam/pam_appl.h>
# endif
#endif

/* 
   Description of the macros used by this file.

   | If your PAM library has the pam_get/putenv functions (PAM versions 
   | after 0.54) the following macro should be defined.
   |
   #define HAVE_PAM_GETENV

   | The following macro activates a workaround for a bug in the solaris 2.6
   | PAM library by setting a pointer to the perl conversation function
   | before every call to a pam function
   |
   #define STATIC_CONV_FUNC
*/


/* this is now determined from configure script */


#if defined( sun ) || defined( __hpux )

  #define CONST_VOID	void
  #define CONST_STRUCT	struct

#else

  #define CONST_STRUCT	const struct
  #define CONST_VOID	const void

#endif

struct perl_pam_data {
  SV* conv_func;
  SV* delay_func;
};

typedef struct pam_conv sPamConv;
typedef struct pam_response sPamResponse;
typedef struct perl_pam_data sPerlPamData;

/* 
 * Gets conv_struct->appdata_ptr and casts it as a sPerlPamData
 */
static sPerlPamData* 
get_perl_pam_data(pamh)
pam_handle_t *pamh;
{
    int res;
    sPamConv *cs;
    res = pam_get_item(pamh, PAM_CONV, (CONST_VOID **)&cs);
    if (res != PAM_SUCCESS || cs == NULL || cs->appdata_ptr == NULL)
        croak("Error in getting pam data!");
    else
        return (sPerlPamData*)cs->appdata_ptr;
}


#ifdef STATIC_CONV_FUNC

    static sPerlPamData *static_perl_pam_data = NULL;

    #define SET_CONV_FUNC(pamh) static_perl_pam_data = get_perl_pam_data(pamh)

#else

    #define SET_CONV_FUNC(pamh)

#endif

static int
not_here(s)
char *s;
{
    croak("%s not implemented on this architecture", s);
    return -1;
}


static int
my_conv_func(num_msg, msg, resp, appdata_ptr)
        int num_msg;
        CONST_STRUCT pam_message **msg;
        sPamResponse **resp;
        void *appdata_ptr;
{
        int i,res_cnt,res;
	STRLEN len;
        sPamResponse *reply = NULL;
        SV *strSV;
        char *str;
        dSP;
	
        ENTER;
        SAVETMPS;

        PUSHMARK(sp);
        for (i = 0; i < num_msg; i++) {
	#ifdef sun
            XPUSHs(sv_2mortal(newSViv((*msg)[i].msg_style)));
            XPUSHs(sv_2mortal(newSVpv((*msg)[i].msg, 0)));
	#else
            XPUSHs(sv_2mortal(newSViv((msg[i])->msg_style)));
            XPUSHs(sv_2mortal(newSVpv((msg[i])->msg, 0)));
	#endif
        }
        PUTBACK;

#ifdef STATIC_CONV_FUNC
	appdata_ptr = static_perl_pam_data;
#endif
	if ( !SvTRUE(((sPerlPamData*)appdata_ptr)->conv_func) )
	    croak("Calling empty conversation function!");
        res_cnt = 
	  perl_call_sv(((sPerlPamData*)appdata_ptr)->conv_func, G_ARRAY);

        SPAGAIN;
	
        if (res_cnt == 1) { // only return code
	  res = POPi;
	  reply = NULL;
        } 
	else if (res_cnt == 2*num_msg + 1) {
	    res = POPi;
	    res_cnt--;
	    if (res_cnt > 0) {
		res_cnt /= 2;
        	reply = malloc( res_cnt * sizeof(sPamResponse));
        	for (i = res_cnt - 1; i >= 0; i--) {
        	    strSV = POPs;
        	    str = SvPV(strSV, len);
        	    reply[i].resp_retcode = POPi;
		    reply[i].resp = malloc(len+1);
		    memcpy(reply[i].resp, str, len);
		    reply[i].resp[len] = 0;
/*
		printf("Code %d and str %s\n",  reply[i].resp_retcode, 
						reply[i].resp);
*/
           	}
	    }
        } 
        else {
	  croak("The output list of the PAM conversation function"
		" must have twice the size of the input list plus one!");
	  res = PAM_CONV_ERR;
	}

        PUTBACK;

        FREETMPS;
        LEAVE;

	*resp = reply;
	return res;
}


/*
 * We must also handle setting a delay function with a prototype:
 *
 *     void (*delay_fn)(int retval, unsigned usec_delay, void *appdata_ptr);
 *
 * by a call to pam_set_item(pamh, PAM_FAIL_DELAY, fail_delay);
 *
 * Works only on Linux-PAM >= 0.68
 */
static void
my_delay_func(status, delay, appdata_ptr)
int status;
unsigned int delay;
void *appdata_ptr;
{
    dSP ;

    if (appdata_ptr == NULL)
        croak("Empty perl pam data");
    if (!SvTRUE(((sPerlPamData*)appdata_ptr)->delay_func))
        croak("Calling empty delay function!");
    
    /* printf("st: %d, dl: %d\n",status,delay); */

    PUSHMARK(sp) ;
    XPUSHs(sv_2mortal(newSViv(status)));
    XPUSHs(sv_2mortal(newSViv(delay)));
    PUTBACK ;

    perl_call_sv(((sPerlPamData*)appdata_ptr)->delay_func, 
		 G_VOID | G_DISCARD);
}

static double
constant(name, arg)
char *name;
int arg;
{
    errno = 0;

    if (strncmp(name, "PAM_", 4) == 0) {
      name = &name[4];
      /* error codes */
      if (strcmp(name, "SUCCESS") == 0)
	  return PAM_SUCCESS;
      else if (strcmp(name, "OPEN_ERR") == 0)
	  return PAM_OPEN_ERR;
      else if (strcmp(name, "SYMBOL_ERR") == 0)
	  return PAM_SYMBOL_ERR;
      else if (strcmp(name, "SERVICE_ERR") == 0)
	  return PAM_SERVICE_ERR;
      else if (strcmp(name, "SYSTEM_ERR") == 0)
	  return PAM_SYSTEM_ERR;
      else if (strcmp(name, "BUF_ERR") == 0)
	  return PAM_BUF_ERR;
      else if (strcmp(name, "PERM_DENIED") == 0)
	  return PAM_PERM_DENIED;
      else if (strcmp(name, "AUTH_ERR") == 0)
	  return PAM_AUTH_ERR;
      else if (strcmp(name, "CRED_INSUFFICIENT") == 0)
	  return PAM_CRED_INSUFFICIENT;
      else if (strcmp(name, "AUTHINFO_UNAVAIL") == 0)
	  return PAM_AUTHINFO_UNAVAIL;
      else if (strcmp(name, "USER_UNKNOWN") == 0)
	  return PAM_USER_UNKNOWN;
      else if (strcmp(name, "MAXTRIES") == 0)
	  return PAM_MAXTRIES;
      else if (strcmp(name, "NEW_AUTHTOK_REQD") == 0 ||
	       strcmp(name, "AUTHTOKEN_REQD") == 0)
      #if defined(HAVE_PAM_NEW_AUTHTOK_REQD)
	  return PAM_NEW_AUTHTOK_REQD;
      #elif defined(HAVE_PAM_AUTHTOKEN_REQD)
          return PAM_AUTHTOKEN_REQD;       /* Old Linux-PAM */
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "ACCT_EXPIRED") == 0)
	  return PAM_ACCT_EXPIRED;
      else if (strcmp(name, "SESSION_ERR") == 0)
	  return PAM_SESSION_ERR;
      else if (strcmp(name, "CRED_UNAVAIL") == 0)
	  return PAM_CRED_UNAVAIL;
      else if (strcmp(name, "CRED_EXPIRED") == 0)
	  return PAM_CRED_EXPIRED;
      else if (strcmp(name, "CRED_ERR") == 0)
	  return PAM_CRED_ERR;
      else if (strcmp(name, "NO_MODULE_DATA") == 0)
	  return PAM_NO_MODULE_DATA;
      else if (strcmp(name, "CONV_ERR") == 0)
	  return PAM_CONV_ERR;
      else if (strcmp(name, "AUTHTOK_ERR") == 0)
	  return PAM_AUTHTOK_ERR;
      else if (strcmp(name, "AUTHTOK_RECOVER_ERR") == 0 ||
	       strcmp(name, "AUTHTOK_RECOVERY_ERR") == 0)
      #if defined(HAVE_PAM_AUTHTOK_RECOVER_ERR)    /* Linux-PAM   */
	  return PAM_AUTHTOK_RECOVER_ERR;
      #elif defined(HAVE_PAM_AUTHTOK_RECOVERY_ERR) /* Solaris PAM */
	  return PAM_AUTHTOK_RECOVERY_ERR;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "AUTHTOK_LOCK_BUSY") == 0)
	  return PAM_AUTHTOK_LOCK_BUSY;
      else if (strcmp(name, "AUTHTOK_DISABLE_AGING") == 0)
	  return PAM_AUTHTOK_DISABLE_AGING;
      else if (strcmp(name, "TRY_AGAIN") == 0)
	  return PAM_TRY_AGAIN;
      else if (strcmp(name, "IGNORE") == 0)
	  return PAM_IGNORE;
      else if (strcmp(name, "ABORT") == 0)
	  return PAM_ABORT;
      else if (strcmp(name, "AUTHTOK_EXPIRED") == 0)
      #if defined(HAVE_PAM_AUTHTOK_EXPIRED)
	  return PAM_AUTHTOK_EXPIRED;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "MODULE_UNKNOWN") == 0)
      #if defined(HAVE_PAM_MODULE_UNKNOWN)  /* Linux-PAM only */
	  return PAM_MODULE_UNKNOWN;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "BAD_ITEM") == 0)
      #if defined(HAVE_PAM_BAD_ITEM)
	  return PAM_BAD_ITEM;
      #else
	  goto not_there;
      #endif

      /* New Linux-PAM return codes */
      else if (strcmp(name, "CONV_AGAIN") == 0)
      #if defined(HAVE_PAM_CONV_AGAIN)
	  return PAM_CONV_AGAIN;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "INCOMPLETE") == 0)
      #if defined(HAVE_PAM_INCOMPLETE)
	  return PAM_INCOMPLETE;
      #else
	  goto not_there;
      #endif

      /* set/get_item constants */
      else if (strcmp(name, "SERVICE") == 0)
	  return PAM_SERVICE;
      else if (strcmp(name, "USER") == 0)
	  return PAM_USER;
      else if (strcmp(name, "TTY") == 0)
	  return PAM_TTY;
      else if (strcmp(name, "RHOST") == 0)
	  return PAM_RHOST;
      else if (strcmp(name, "CONV") == 0)
	  return PAM_CONV;
      /* module flags */
      /*
      else if (strcmp(name, "AUTHTOK") == 0)
	  return PAM_CONV;
      else if (strcmp(name, "OLDAUTHTOK") == 0)
	  return PAM_CONV;
      */
      else if (strcmp(name, "RUSER") == 0)
	  return PAM_RUSER;
      else if (strcmp(name, "USER_PROMPT") == 0)
	  return PAM_USER_PROMPT;
      else if (strcmp(name, "FAIL_DELAY") == 0)
      #if defined(HAVE_PAM_FAIL_DELAY)
	  return PAM_FAIL_DELAY;
      #else
	  goto not_there;
      #endif

      /* global flag */
      else if (strcmp(name, "SILENT") == 0)
	  return PAM_SILENT;
      /* pam_authenticate falgs */
      else if (strcmp(name, "DISALLOW_NULL_AUTHTOK") == 0)
	  return PAM_DISALLOW_NULL_AUTHTOK;
      /* pam_set_cred flags */
      else if (strcmp(name, "ESTABLISH_CRED") == 0 ||
	       strcmp(name, "CRED_ESTABLISH") == 0)
      #if defined(HAVE_PAM_ESTABLISH_CRED)
	  return PAM_ESTABLISH_CRED;
      #elif defined(HAVE_PAM_CRED_ESTABLISH)   /* Old Linux-PAM */
	  return PAM_CRED_ESTABLISH;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "DELETE_CRED") == 0 ||
	       strcmp(name, "CRED_DELETE") == 0)
      #if defined(HAVE_PAM_DELETE_CRED)
	  return PAM_DELETE_CRED;
      #elif defined(HAVE_PAM_CRED_DELETE)       /* Old Linux-PAM */
	  return PAM_CRED_DELETE;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "REINITIALIZE_CRED") == 0 ||
	       strcmp(name, "CRED_REINITIALIZE") == 0)
      #if defined(HAVE_PAM_REINITIALIZE_CRED)
	  return PAM_REINITIALIZE_CRED;
      #elif defined(HAVE_PAM_CRED_REINITIALIZE)
	  return PAM_CRED_REINITIALIZE;    /* Old Linux-PAM */
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "REFRESH_CRED") == 0 ||
	       strcmp(name, "CRED_REFRESH") == 0)
      #if defined(HAVE_PAM_REFRESH_CRED)
	  return PAM_REFRESH_CRED;
      #elif defined(HAVE_PAM_CRED_REFRESH)
	  return PAM_CRED_REFRESH;         /* Old Linux-PAM */
      #else
	  goto not_there;
      #endif
      /* pam_chauthtok flags */
      else if (strcmp(name, "CHANGE_EXPIRED_AUTHTOK") == 0)
	  return PAM_CHANGE_EXPIRED_AUTHTOK;

      /* message style constants */
      else if (strcmp(name, "PROMPT_ECHO_OFF") == 0)
	  return PAM_PROMPT_ECHO_OFF;
      else if (strcmp(name, "PROMPT_ECHO_ON") == 0)
	  return PAM_PROMPT_ECHO_ON;
      else if (strcmp(name, "ERROR_MSG") == 0)
	  return PAM_ERROR_MSG;
      else if (strcmp(name, "TEXT_INFO") == 0)
	  return PAM_TEXT_INFO;
      else if (strcmp(name, "RADIO_TYPE") == 0)
      #if defined(HAVE_PAM_RADIO_TYPE)
	  return PAM_RADIO_TYPE;
      #else
	  goto not_there;
      #endif
      else if (strcmp(name, "BINARY_PROMPT") == 0)
      #if defined(HAVE_PAM_BINARY_PROMPT)
	  return PAM_BINARY_PROMPT;
      #else
	  goto not_there;
      #endif

      /* I'm not sure if these are really needed... */
      /*
      else if (strcmp(name, "MAX_MSG_SIZE") == 0)
	  return PAM_MAX_MSG_SIZE;
      else if (strcmp(name, "MAX_RESP_SIZE") == 0)
	  return PAM_MAX_RESP_SIZE;
      */
    } 
    else if (strncmp(name, "HAVE_PAM_", 9) == 0) {
      name = &name[9];

      if (strcmp(name, "FAIL_DELAY") == 0)
      #if defined(HAVE_PAM_FAIL_DELAY)
	  return 1;
      #else
	  return 0;
      #endif
      else if (strcmp(name, "ENV_FUNCTIONS") == 0)
      #if defined(HAVE_PAM_GETENV)
	  return 1;
      #else
	  return 0;
      #endif
      /*
      else if (strcmp(name, "HAVE_PAM_SYSTEM_LOG") == 0)
      #if defined(HAVE_PAM_SYSTEM_LOG)
	  return 1;
      #else
	  return 0;
      #endif
      */
    }

    errno = EINVAL;
    return 0;

not_there:
    errno = ENOSYS;
    return 0;
}


#line 472 "PAM.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%"UVxf")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 616 "PAM.c"

XS_EUPXS(XS_Authen__PAM_constant); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_constant)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, arg");
    {
	char *	name = (char *)SvPV_nolen(ST(0))
;
	int	arg = (int)SvIV(ST(1))
;
	double	RETVAL;
	dXSTARG;

	RETVAL = constant(name, arg);
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM__pam_start); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM__pam_start)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "service_name, user_sv, func, pamh");
    {
	const char *	service_name = (const char *)SvPV_nolen(ST(0))
;
	SV *	user_sv = ST(1)
;
	SV *	func = ST(2)
;
	pam_handle_t *	pamh;
#line 480 "PAM.xs"
	  sPamConv conv_st;
	  const char *user;
#line 656 "PAM.c"
	int	RETVAL;
	dXSTARG;
#line 483 "PAM.xs"
	  user = SvOK(user_sv) ? SvPV_nolen(user_sv) : NULL;

	  conv_st.conv = my_conv_func;
	  conv_st.appdata_ptr = malloc(sizeof(sPerlPamData));
	  ((sPerlPamData*)conv_st.appdata_ptr)->conv_func = newSVsv(func);
	  ((sPerlPamData*)conv_st.appdata_ptr)->delay_func = newSViv(0);

	  RETVAL = pam_start(service_name, user, &conv_st, &pamh);
#line 668 "PAM.c"
	sv_setref_pv(ST(3), Nullch, (void*)pamh);
	SvSETMAGIC(ST(3));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_end); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_end)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, pam_status=PAM_SUCCESS");
    {
	pam_handle_t *	pamh;
	int	pam_status;
#line 500 "PAM.xs"
	  sPerlPamData *data;
	  int res;
#line 689 "PAM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_end",
			"pamh")
;

	if (items < 2)
	    pam_status = PAM_SUCCESS;
	else {
	    pam_status = (int)SvIV(ST(1))
;
	}
#line 503 "PAM.xs"
	  data = get_perl_pam_data(pamh);
          SvREFCNT_dec(data->conv_func); 
          SvREFCNT_dec(data->delay_func); 
	  free(data);

          RETVAL = pam_end(pamh, pam_status);
#line 716 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_set_item); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_set_item)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pamh, item_type, item");
    {
	pam_handle_t *	pamh;
	int	item_type = (int)SvIV(ST(1))
;
	SV *	item = ST(2)
;
#line 518 "PAM.xs"
	  sPerlPamData *data;
	  int res;
#line 738 "PAM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_set_item",
			"pamh")
;
#line 521 "PAM.xs"
	  if (item_type == PAM_CONV) {
	      data = get_perl_pam_data(pamh);
	      sv_setsv(data->conv_func, item);
	      RETVAL = PAM_SUCCESS;
	  }
#if defined(HAVE_PAM_FAIL_DELAY)
          else if (item_type == PAM_FAIL_DELAY) {
	      data = get_perl_pam_data(pamh);
	      sv_setsv(data->delay_func, item);
	      if (SvTRUE(item))
	          RETVAL = pam_set_item( pamh, item_type, my_delay_func);
	      else
	          RETVAL = pam_set_item( pamh, item_type, NULL);
	  }
#endif
	  else
#if (PERL_API_REVISION == 5 && PERL_API_VERSION >= 5)
	      RETVAL = pam_set_item( pamh, item_type, SvPV_nolen(item));
#else
	      RETVAL = pam_set_item( pamh, item_type, SvPV(item,na));
#endif
#line 773 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_get_item); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_get_item)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "pamh, item_type, item");
    {
	pam_handle_t *	pamh;
	int	item_type = (int)SvIV(ST(1))
;
	SV *	item = ST(2)
;
#line 551 "PAM.xs"
	  char *c;
	  sPerlPamData *data;
	  int res;
#line 796 "PAM.c"
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_get_item",
			"pamh")
;
#line 555 "PAM.xs"
	  if (item_type == PAM_CONV) {
	      data = get_perl_pam_data(pamh);
	      sv_setsv(item, data->conv_func);
	      RETVAL = PAM_SUCCESS;
	  }
#if defined(HAVE_PAM_FAIL_DELAY)
          else if (item_type == PAM_FAIL_DELAY) {
	      data = get_perl_pam_data(pamh);
	      sv_setsv(item, data->delay_func);
	      RETVAL = PAM_SUCCESS;
 	  }
#endif
	  else {
	      RETVAL = pam_get_item( pamh, item_type, (CONST_VOID **)&c);
	      sv_setpv(item, c);
	  }
#line 826 "PAM.c"
	ST(2) = item;
	SvSETMAGIC(ST(2));
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_strerror); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_strerror)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, errnum");
    {
	pam_handle_t *	pamh;
	int	errnum = (int)SvIV(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_strerror",
			"pamh")
;
#line 580 "PAM.xs"
#if defined(PAM_STRERROR_NEEDS_PAMH)
	  RETVAL = pam_strerror(pamh, errnum);
#else
	  RETVAL = pam_strerror(errnum);
#endif
#line 863 "PAM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

#if defined(HAVE_PAM_GETENV)
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Authen__PAM_pam_putenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_putenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, name_value");
    {
	pam_handle_t *	pamh;
	const char *	name_value = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_putenv",
			"pamh")
;
#line 594 "PAM.xs"
	  RETVAL = pam_putenv(pamh, name_value);
#line 897 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_getenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_getenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, name");
    {
	pam_handle_t *	pamh;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_getenv",
			"pamh")
;
#line 603 "PAM.xs"
	  RETVAL = pam_getenv(pamh, name);
#line 928 "PAM.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM__pam_getenvlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM__pam_getenvlist)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pamh");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	pam_handle_t *	pamh;
#line 611 "PAM.xs"
	  char **res;
	  int i;
	  int c;
#line 949 "PAM.c"

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::_pam_getenvlist",
			"pamh")
;
#line 615 "PAM.xs"
	  res = pam_getenvlist(pamh);
	  c = 0;
	  while (res[c] != 0)
	      c++;
	  EXTEND(sp, c);
	  for (i = 0; i < c; i++)
	      PUSHs(sv_2mortal(newSVpv(res[i],0)));
#line 968 "PAM.c"
	PUTBACK;
	return;
    }
}

#else
#define XSubPPtmpAAAB 1


XS_EUPXS(XS_Authen__PAM_pam_putenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_putenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, name_value");
    {
	pam_handle_t *	pamh;
	const char *	name_value = (const char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_putenv",
			"pamh")
;
#line 630 "PAM.xs"
	  not_here("pam_putenv");
#line 1002 "PAM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_getenv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_getenv)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, name");
    {
	pam_handle_t *	pamh;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	const char *	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_getenv",
			"pamh")
;
#line 637 "PAM.xs"
	  not_here("pam_getenv");
#line 1032 "PAM.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM__pam_getenvlist); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM__pam_getenvlist)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pamh");
    {
	pam_handle_t *	pamh;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::_pam_getenvlist",
			"pamh")
;
#line 644 "PAM.xs"
	  not_here("pam_getenvlist");
#line 1058 "PAM.c"
    }
    XSRETURN_EMPTY;
}

#endif
#if defined(HAVE_PAM_FAIL_DELAY)
#define XSubPPtmpAAAC 1


XS_EUPXS(XS_Authen__PAM_pam_fail_delay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_fail_delay)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, musec_delay");
    {
	pam_handle_t *	pamh;
	unsigned int	musec_delay = (unsigned int)SvUV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_fail_delay",
			"pamh")
;
#line 656 "PAM.xs"
	  RETVAL = pam_fail_delay(pamh, musec_delay);
#line 1092 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#else
#define XSubPPtmpAAAD 1


XS_EUPXS(XS_Authen__PAM_pam_fail_delay); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_fail_delay)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, musec_delay");
    {
	pam_handle_t *	pamh;
	unsigned int	musec_delay = (unsigned int)SvUV(ST(1))
;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_fail_delay",
			"pamh")
;
#line 667 "PAM.xs"
	  not_here("pam_fail_delay");
#line 1124 "PAM.c"
    }
    XSRETURN_EMPTY;
}

#endif

XS_EUPXS(XS_Authen__PAM_pam_authenticate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_authenticate)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, flags=0");
    {
	pam_handle_t *	pamh;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_authenticate",
			"pamh")
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 677 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_authenticate(pamh,flags);
#line 1162 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_setcred); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_setcred)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pamh, flags");
    {
	pam_handle_t *	pamh;
	int	flags = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_setcred",
			"pamh")
;
#line 687 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_setcred(pamh,flags);
#line 1194 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_acct_mgmt); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_acct_mgmt)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, flags=0");
    {
	pam_handle_t *	pamh;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_acct_mgmt",
			"pamh")
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 697 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_acct_mgmt(pamh,flags);
#line 1232 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_open_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_open_session)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, flags=0");
    {
	pam_handle_t *	pamh;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_open_session",
			"pamh")
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 707 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_open_session(pamh,flags);
#line 1270 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_close_session); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_close_session)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, flags=0");
    {
	pam_handle_t *	pamh;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_close_session",
			"pamh")
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 717 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_close_session(pamh, flags);
#line 1308 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Authen__PAM_pam_chauthtok); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Authen__PAM_pam_chauthtok)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pamh, flags=0");
    {
	pam_handle_t *	pamh;
	int	flags;
	int	RETVAL;
	dXSTARG;

	if (SvROK(ST(0))) {
	    IV tmp = SvIV((SV*)SvRV(ST(0)));
	    pamh = INT2PTR(pam_handle_t *,tmp);
	}
	else
	    Perl_croak_nocontext("%s: %s is not a reference",
			"Authen::PAM::pam_chauthtok",
			"pamh")
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 727 "PAM.xs"
	  SET_CONV_FUNC(pamh);
	  RETVAL = pam_chauthtok(pamh, flags);
#line 1346 "PAM.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Authen__PAM); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Authen__PAM)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Authen::PAM::constant", XS_Authen__PAM_constant, file, "$$");
        (void)newXSproto_portable("Authen::PAM::_pam_start", XS_Authen__PAM__pam_start, file, "$$$$");
        (void)newXSproto_portable("Authen::PAM::pam_end", XS_Authen__PAM_pam_end, file, "$;$");
        (void)newXSproto_portable("Authen::PAM::pam_set_item", XS_Authen__PAM_pam_set_item, file, "$$$");
        (void)newXSproto_portable("Authen::PAM::pam_get_item", XS_Authen__PAM_pam_get_item, file, "$$$");
        (void)newXSproto_portable("Authen::PAM::pam_strerror", XS_Authen__PAM_pam_strerror, file, "$$");
#if XSubPPtmpAAAA
        (void)newXSproto_portable("Authen::PAM::pam_putenv", XS_Authen__PAM_pam_putenv, file, "$$");
        (void)newXSproto_portable("Authen::PAM::pam_getenv", XS_Authen__PAM_pam_getenv, file, "$$");
        (void)newXSproto_portable("Authen::PAM::_pam_getenvlist", XS_Authen__PAM__pam_getenvlist, file, "$");
#endif
#if XSubPPtmpAAAB
        (void)newXSproto_portable("Authen::PAM::pam_putenv", XS_Authen__PAM_pam_putenv, file, "$$");
        (void)newXSproto_portable("Authen::PAM::pam_getenv", XS_Authen__PAM_pam_getenv, file, "$$");
        (void)newXSproto_portable("Authen::PAM::_pam_getenvlist", XS_Authen__PAM__pam_getenvlist, file, "$");
#endif
#if XSubPPtmpAAAC
        (void)newXSproto_portable("Authen::PAM::pam_fail_delay", XS_Authen__PAM_pam_fail_delay, file, "$$");
#endif
#if XSubPPtmpAAAD
        (void)newXSproto_portable("Authen::PAM::pam_fail_delay", XS_Authen__PAM_pam_fail_delay, file, "$$");
#endif
        (void)newXSproto_portable("Authen::PAM::pam_authenticate", XS_Authen__PAM_pam_authenticate, file, "$;$");
        (void)newXSproto_portable("Authen::PAM::pam_setcred", XS_Authen__PAM_pam_setcred, file, "$$");
        (void)newXSproto_portable("Authen::PAM::pam_acct_mgmt", XS_Authen__PAM_pam_acct_mgmt, file, "$;$");
        (void)newXSproto_portable("Authen::PAM::pam_open_session", XS_Authen__PAM_pam_open_session, file, "$;$");
        (void)newXSproto_portable("Authen::PAM::pam_close_session", XS_Authen__PAM_pam_close_session, file, "$;$");
        (void)newXSproto_portable("Authen::PAM::pam_chauthtok", XS_Authen__PAM_pam_chauthtok, file, "$;$");

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#if XSubPPtmpAAAB
#endif
#if XSubPPtmpAAAC
#endif
#if XSubPPtmpAAAD
#endif
#line 1419 "PAM.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

